var RED = require(process.env.NODE_RED_HOME+"/red/red");
var Go = require('gonode').Go;

function  HadoopMQTTBridge(n){
	RED.nodes.createNode(this, n)
	var go = new Go({path: 'HadoopMQTTBridge.go', initAtOnce: true}, function(err) {
		if(err) {
			console.log('Error initializing.\n' + err);
			return;
		}

		go.on('error', function(err) {
			console.log('Error from gonode.\n'
				+ 'Is it from the internal parser?' + (err.parser ? 'yes' : 'no')
				+ '\nActual error: \n'
				+ err.data.toString());
		});

		go.execute({text: 'Connect'}, function(result, response) {
			if(!result.ok) {
				console.log('Something went wrong with the \'Connect\' command.');
			} else {
				console.log('Go responded: ' + response.text + '\n\n');
			}
		});

		go.execute({text: 'Subscribe'}, function(result, response) {
			if(!result.ok) {
				console.log('Something went wrong with the \'Subscribe\' command.');
			} else {
				console.log('Go responded: ' + response.text + '\n\n');
			}
		});

		go.execute({text: 'Publish'}, function(result, response) {
			if(!result.ok) {
				console.log('Something went wrong with the \'Publish\' command.');
			} else {
				console.log('Go responded: ' + response.text + '\n\n');
			}
		});

		go.execute({text: 'Unsubscribe'}, function(result, response) {
			if(!result.ok) {
				console.log('Something went wrong with the \'Unsubscribe\' command.');
			} else {
				console.log('Go responded: ' + response.text + '\n\n');
			}
		});

		go.execute({text: 'Disconnect'}, function(result, response) {
			if(!result.ok) {
				console.log('Something went wrong with the \'Disconnect\' command.');
			} else {
				console.log('Go responded: ' + response.text + '\n\n');
			}
		});

		go.close();
	});
}

RED.nodes.registerType("HadoopMQTTBridge", HadoopMQTTBridge);
