package ghhx

import (
	"net/http"
	"bytes"
	"crypto/tls"
)

func CreateTable (name string) (*http.Response, error){
	url := "http://localhost:8080/"  + name + "/schema"

	xml := "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	xml += "<TableSchema name =\""
	xml += name
	xml += "\" >"
	xml += "	<ColumnSchema name =\"cf2\" />"
	xml += "</TableSchema>"

	req, err := http.NewRequest("POST", url, bytes.NewBuffer([]byte(xml)))
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: false},
	}

	client := &http.Client{Transport: tr}
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	return resp, nil
}
