package ghhx

import (
	"net/http"
	"fmt"
	"io/ioutil"
	"crypto/tls"
//	"bytes"
)

func CheckTable (table string) (*http.Response, error){
	url := "http://localhost:8080/"  + table + "/schema"

	req, err := http.NewRequest("GET", url, nil)
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
	}

	client := &http.Client{Transport: tr}
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	return resp, nil
}

func GetRow (table, row string) (*http.Response, error){
	url := "http://localhost:8080/"  + table + "/" + row

	req, err := http.NewRequest("GET", url, nil)
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
	}

	client := &http.Client{Transport: tr}
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	fmt.Println("response Status:", resp.Status)
	fmt.Println("response Headers:", resp.Header)
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println("response Body:", string(body))


	return resp, nil
}

func GetColumn (table, row, column string) (*http.Response, error){
	url := "http://localhost:8080/"  + table + "/" + row + "/" + column

	req, err := http.NewRequest("GET", url, nil)
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
	}

	client := &http.Client{Transport: tr}
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	fmt.Println("response Status:", resp.Status)
	fmt.Println("response Headers:", resp.Header)
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println("response Body:", string(body))


	return resp, nil
}
