package ghhx

import (
	"fmt"
	"strings"
	"net/http"
	"bytes"
	"io/ioutil"
	"crypto/tls"
	b64 "encoding/base64"
)

func WriteRow (table, row, col, cell string) (*http.Response, error){
	url := "http://localhost:8080/"  + table + "/" + row

	rowEnc := b64.URLEncoding.EncodeToString([]byte(row))
	colEnc := b64.URLEncoding.EncodeToString([]byte(col))
	cellEnc := b64.URLEncoding.EncodeToString([]byte(cell))
	fmt.Println(rowEnc)
	fmt.Println(colEnc)
	fmt.Println(cellEnc)
	fmt.Println()

	xml := "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>"
	xml += "<CellSet><Row key=\""
	xml += rowEnc
	xml += "\"><Cell column=\""
	xml += colEnc
	xml += "\">"
	xml += cellEnc
	xml += "</Cell></Row></CellSet>"

	req, err := http.NewRequest("PUT", url, bytes.NewBuffer([]byte(xml)))
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: false},
	}

	client := &http.Client{Transport: tr}
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	fmt.Println("response Status:", resp.Status)
	fmt.Println("response Headers:", resp.Header)
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println("response Body:", string(body))

	return resp, nil
}

func AddFamily (table, colf string) (*http.Response, error){
	url := "http://localhost:8080/"  + table + "/schema"

//curl -vi -X GET -H Accept: text/xml http://localhost:8080/test4/schema
	req, err := http.NewRequest("GET", url, nil)
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
	}

	client := &http.Client{Transport: tr}
	resp, err := client.Do(req)
	if err != nil {
		return nil, err
	}
	body, _ := ioutil.ReadAll(resp.Body)
	xml := string(body)
	s := strings.Split(xml, "/></")
	xml, xml2 := s[0], s[1]
	xml += "/><ColumnSchema name=\""
	xml += colf
	xml += "\"/></"
	xml += xml2
/*
	fmt.Println("Final XML Request")
	fmt.Println(xml)
	fmt.Println()
*/
	req, err = http.NewRequest("PUT", url, bytes.NewBuffer([]byte(xml)))
	req.Header.Set("Content-Type", "text/xml")
	req.Header.Set("Accept", "text/xml")

	resp, err = client.Do(req)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()

	fmt.Println("response Status:", resp.Status)
	fmt.Println("response Headers:", resp.Header)
	body, _ = ioutil.ReadAll(resp.Body)
	fmt.Println("response Body:", string(body))

	return resp, nil
}
